unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    procedure FormCreate(Sender: TObject);
  private
    procedure Form1MouseEnter(Sender: TObject);
    procedure Form1MouseLeave(Sender: TObject);
    procedure Panel1MouseEnter(Sender: TObject);
    procedure Panel1MouseLeave(Sender: TObject);
    procedure Panel2MouseEnter(Sender: TObject);
    procedure Panel2MouseLeave(Sender: TObject);


  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  Panel1.OnMouseEnter:=@Panel1MouseEnter;
  Panel1.OnMouseLeave:=@Panel1MouseLeave;
  Panel2.OnMouseEnter:=@Panel2MouseEnter;
  Panel2.OnMouseLeave:=@Panel2MouseLeave;

  Form1.OnMouseEnter:=@Form1MouseEnter;
  Form1.OnMouseLeave:=@Form1MouseLeave;
end;

procedure TForm1.Form1MouseEnter(Sender: TObject);
begin
 if Sender  is TForm then caption := 'Maus in der Form';
end;

procedure TForm1.Form1MouseLeave(Sender: TObject);
begin
 if Sender  is TForm then caption := 'Keine Maus in der Form, aber in einem Panel';
end;



procedure TForm1.Panel1MouseEnter(Sender: TObject);
begin
 if Sender = Panel1 then Panel1.Caption:= 'Maus drin';
  Panel1.Color:= clLime;
end;

procedure TForm1.Panel1MouseLeave(Sender: TObject);
begin
  if Sender = Panel1 then Panel1.Caption:= 'Maus raus';
  Panel1.Color:= clDefault;
end;

procedure TForm1.Panel2MouseEnter(Sender: TObject);
begin
 if Sender = Panel2 then Panel2.Caption:= 'Maus drin';
  Panel2.Color:= clBlue;
end;

procedure TForm1.Panel2MouseLeave(Sender: TObject);
begin
  if Sender = Panel2 then Panel2.Caption:= 'Maus raus';
  Panel2.Color:= clDefault;
end;


end.

